## charybdis 4.1.1

=== doc/oper-guide/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  epub3      to make an epub3"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Charybdisoperatorguide.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Charybdisoperatorguide.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Charybdisoperatorguide"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Charybdisoperatorguide"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3:
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

.PHONY: dummy
dummy:
	$(SPHINXBUILD) -b dummy $(ALLSPHINXOPTS) $(BUILDDIR)/dummy
	@echo
	@echo "Build finished. Dummy builder generates no files."

## charybdis 3.3.0

=== debian/changelog ===
charybdis (3.3.0-7ubuntu1) precise; urgency=low

  * debian/patches/sqlite_linking.patch: shuffle around LDFLAGS in file
    bandb/Makefile.in to properly link against sqlite3.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 16 Jan 2012 18:54:30 -0500

charybdis (3.3.0-7) unstable; urgency=low

  * patch: default NICKLEN to 30 to fit a commonly used value and the new
    default default (used on irc.staticbox.net at least)

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 29 Nov 2011 18:09:43 -0500

charybdis (3.3.0-6) unstable; urgency=low

  * Conflict with ircd-ratbox (Closes: #649070)
  * Conflict with oftc-hybrid (Closes: #649071)

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 21 Nov 2011 20:03:27 -0500

charybdis (3.3.0-5) unstable; urgency=low

  * add all undocumented copyrights - some files do not have copyright
    headers still, it is assumed they are GPL-2

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 10 Nov 2011 23:07:37 -0500

charybdis (3.3.0-4) unstable; urgency=low

  * add debug flags, simplify configure args passing
  * fix my email address
  * fixup gnutls dependencies

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 07 Nov 2011 17:53:33 -0500

charybdis (3.3.0-3) unstable; urgency=low

  * make maximum nick length customizable
  * make this compile in squeeze without OpenSSL

 -- Antoine Beaupré <anarcat@koumbit.org>  Sun, 06 Nov 2011 16:27:49 -0500

charybdis (3.3.0-2) unstable; urgency=low

  * remove logfiles on purge
  * port to non-linux kernels
  * IPv6 support
  * provide ircd
  * fix initscript stop
  * allow building with OpenSSL
  * patches, forwarded upstream:
    * do not build with rpath
    * fix clean target

 -- Antoine Beaupré <anarcat@debian.org>  Sun, 06 Nov 2011 12:28:43 -0500

charybdis (3.3.0-1) unstable; urgency=low

  * Initial release (Closes: #485553)
  * patches, forwarded upstream:
    * non-static sqlite
    * proper ircd.conf sample file
    * fix various install paths
    * no hardcoded bandb environment

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 26 Oct 2011 23:16:38 -0400

=== debian/control ===
Source: charybdis
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Antoine Beaupré <anarcat@debian.org>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, autoconf, pkg-config, libgnutls-dev, libz-dev, libsqlite3-dev, bison | byacc, flex
Standards-Version: 3.9.2
Homepage: https://www.stack.nl/~jilles/irc/#charybdis
Vcs-Git: git://git.debian.org/collab-maint/charybdis.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/charybdis.git;a=summary

Package: charybdis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgnutls26, libz1, libsqlite3-0, adduser
Conflicts: ircd-ratbox, oftc-hybrid
Provides: ircd
Description: fast, scalable irc server
 Charybdis is a fast, scalable IRC server, capable of supporting
 tens of thousands of connections. It supports SSL and X.509
 certificate challenge-response authentication.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

ifeq ($(DEB_HOST_ARCH_OS), linux)
    CONFIGURE_ARGS+=--enable-epoll
else ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
    CONFIGURE_ARGS+=--enable-kqueue
else ifeq ($(DEB_HOST_ARCH_OS), solaris)
    CONFIGURE_ARGS+=--enable-ports
else
    CONFIGURE_ARGS+=--enable-poll
endif

ifdef DEB_DEBUG
   CONFIGURE_ARGS+=--enable-warnings --enable-iodebug
endif

# allow users to build with OpenSSL even if it possibly breaks the
# GPL, as we have no exception from all the authors of ircd
#
# this is not necessary in Wheezy, as there is an OpenSSL
# compatibility layer in GNUTLS
#
# for this to work, you need to manually install libssl-dev
export DEB_USE_OPENSSL

ifdef DEB_USE_OPENSSL
    CONFIGURE_ARGS+=--enable-openssl
else
    CONFIGURE_ARGS+=--disable-openssl
endif

ifdef DEB_NICKLEN
    CONFIGURE_ARGS+=--with-nicklen=$(DEB_NICKLEN)
endif

override_dh_auto_configure:
	autoconf
	./configure --prefix=/usr --with-confdir=/etc/charybdis \
		${CONFIGURE_ARGS} \
		--with-logdir=/var/log/charybdis \
		--with-moduledir=/usr/lib/charybdis/modules \
		--with-helpdir=/usr/share/doc/charybdis/help \
		--bindir=/usr/lib/charybdis \
		--enable-ipv6

%:
	dh $@

## charybdis 3.4.2

=== debian/changelog ===
charybdis (3.4.2-5~deb8u1) stable; urgency=high

  * switch to new anonscm hostnames
  * initialise gnutls properly (Closes: #768339, #705369)
  * add fix for CVE-2015-5290, cherry-picked from upstream d5f856c^..172b58f

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 13 Nov 2015 16:35:35 -0500

charybdis (3.4.2-4) unstable; urgency=medium

  * remove duplicate library depends with shlibs (Closes: #750833)
  * make git-dch work
  * bump standards version (no change) and fix homepage

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 09 Jun 2014 20:29:47 -0400

charybdis (3.4.2-3) unstable; urgency=low

  [Hideki Yamane]
  * specify "-fi" option to autoreconf fix FTBFS (Closes: #724077)

  [Antoine Beaupré]
  * do not ship files in /var/run

 -- Antoine Beaupré <anarcat@debian.org>  Sat, 20 Jul 2013 11:02:06 -0400

charybdis (3.4.2-2) unstable; urgency=low

  * fix configure.ac patch so it has proper format (Closes: #715511)
  * update to standards 3.9.4, no change

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 17 Jul 2013 20:40:50 -0400

charybdis (3.4.2-1) unstable; urgency=low

  * new upstream release (Closes: #684191, #701438, #711152)
  * significantly cleanup the install layout so that libraries are all in
    a private directory, .la files are not installed (Closes: #655624),
    binaries are in /usr/bin again (with charybdis- prefix), and the
    manpage doesn't conflict with other ircd(8) manpages.
  * this makes charydbis *not* conflict with other ircds
  * upgrade to dh 9 for better autotools support and hardening flags
  * hardening flags are disabled because of upstream issues, see TODO
  * change branch layout to follow upstream layout: upstream is on the
    master branch
  * dropped patches:
    * default-nicklen: upstream bumped it to 31 (we were at 30)
    * CVE-2012-6084.patch: merged upstream
    * cleanup-bandb-properly: merged upstream
    * no_hardcoded_bandb_dpath: forgot why it is there (?!)
    * no_rpath: we ship in private directories
  * remaining patches have been re-forwarded upstream as their old
    bugtracker was destroyed
  * new patches:
    * extra-clean: some generated files were left around after clean
    * gnutls.patch: restore gnutls support removed from upstream, but
      readded at our request - gnutls support is still problematic
      however, see: #705369 for followup
  * rerolled patch non-static-sqlite to fix ftbs with ld --as-needed
    (Closes: #655012)
  * fix permissions on /etc/charybdis so it's not readable by all
  * provide debugging symbols, in a separate package

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 04 Jun 2013 22:04:22 -0400

charybdis (3.3.0-8) unstable; urgency=low

  * patch: use libgnutls 3.0 at least

 -- Antoine Beaupré <anarcat@debian.org>  Sun, 25 Mar 2012 21:44:05 -0400

charybdis (3.3.0-7.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix remote denial of service vulnerability
    CVE-2012-6084 (Closes: #697092).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 02 Jan 2013 20:57:36 +0100

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,9 @@
 export DH_OPTIONS
 
 DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
+
+# workaround for https://github.com/atheme/charybdis/issues/27
+export DEB_BUILD_MAINT_OPTIONS=hardening=-all
 
 ifeq ($(DEB_HOST_ARCH_OS), linux)
     CONFIGURE_ARGS+=--enable-epoll
@@ -44,7 +47,7 @@
 ifdef DEB_USE_OPENSSL
     CONFIGURE_ARGS+=--enable-openssl
 else
-    CONFIGURE_ARGS+=--disable-openssl
+    CONFIGURE_ARGS+=--disable-openssl --enable-gnutls
 endif
 
 ifdef DEB_NICKLEN
@@ -52,14 +55,31 @@
 endif
 
 override_dh_auto_configure:
-	autoconf
-	./configure --prefix=/usr --with-confdir=/etc/charybdis \
+	autoreconf -fi
+	cd libratbox ; autoreconf # necessary because we patch configure.ac
+	cd libratbox ; automake
+	dh_auto_configure -- --prefix=/usr --with-confdir=/etc/charybdis \
 		${CONFIGURE_ARGS} \
+		--with-program-prefix=charybdis- \
+		--libdir=/usr/lib/charybdis \
+		--libexecdir=/usr/lib \
+		--with-rundir=/var/run \
+		--localstatedir=/var/lib \
 		--with-logdir=/var/log/charybdis \
 		--with-moduledir=/usr/lib/charybdis/modules \
 		--with-helpdir=/usr/share/doc/charybdis/help \
-		--bindir=/usr/lib/charybdis \
 		--enable-ipv6
 
+override_dh_auto_install:
+	dh_auto_install --destdir=debian/charybdis
+	rmdir $(CURDIR)/debian/charybdis/var/run/charybdis || true
+        # remove when it fails, it means upstream stopped shipping .la files, yay
+	rm $(CURDIR)/debian/charybdis/usr/lib/charybdis/libratbox.la
+        # remove when this fail (when the binary is renamed), see https://github.com/atheme/charybdis/pull/28
+	mv $(CURDIR)/debian/charybdis/usr/bin/charybdis-genssl.sh $(CURDIR)/debian/charybdis/usr/bin/charybdis-genssl
+
+override_dh_strip:
+	dh_strip --dbg-package=charybdis-dbg
+
 %:
-	dh $@ 
+	dh $@ --with autotools_dev

## charybdis 3.5.0

=== debian/changelog ===
charybdis (3.5.0-1build1) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:23:45 +0000

charybdis (3.5.0-1) unstable; urgency=medium

  * new upstream release, see this post for details:
    http://www.charybdis.io/2016/01/05/charybdis-3.5.0-release.html
    (Closes: #703546)
  * fix homepage to use the new upstream URL (Closes: #812527)
  * remove patches factored in upstream:
    * gnutls30: upstream supports both 2.x and 3.x, apparently
    * non-static-sqlite: now a flag, that we use
    * fix-paths: merged upstream
    * CVE-2015-5290: fixed upstream
    * gnutls, libratbox-gnutls-add-gnutls-v3-api-compatibility-wit: fixed
      upstream
    * ircd.conf: will never be merged upstream, just move it during the build
  * forwarded extra-clean patch upstream
  * new patches:
    * gnutls34.patch: fix build under gnutls 3.4 (Closes: #812655)

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 15 Feb 2016 20:16:45 -0500

charybdis (3.4.2-5) unstable; urgency=high

  * switch to new anonscm hostnames
  * initialise gnutls properly (Closes: #768339, #705369)
  * add fix for CVE-2015-5290, cherry-picked from upstream d5f856c^..172b58f

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 13 Nov 2015 16:35:35 -0500

=== debian/control ===
Source: charybdis
Section: net
Priority: optional
Maintainer: Antoine Beaupré <anarcat@debian.org>
Build-Depends: debhelper (>= 9.0.0),
               autotools-dev,
               autoconf,
               automake,
               libtool,
               pkg-config,
               libgnutls28-dev,
               libgcrypt11-dev,
               libz-dev,
               libsqlite3-dev,
               bison | byacc,
               flex
Standards-Version: 3.9.5
Homepage: http://www.charybdis.io/
Vcs-Git: git://anonscm.debian.org/collab-maint/charybdis.git -b debian
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/charybdis.git;a=summary

Package: charybdis
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser
Provides: ircd
Description: fast, scalable irc server
 Charybdis is a highly scalable IRC server which presently implements
 the IRCv3.1 client protocol with some additional components of
 IRCv3.2. Development of charybdis began in 2005 as a proposed
 replacement to freenode’s hyperion ircd, designed for use by any
 network, with roots in ircd-ratbox and ircu. Over time, charybdis has
 developed, tested and demonstrated many of the features commonly seen
 in modern IRC networks.
 .
 Interesting features that Charybdis has include:
 .
  * SASL support — charybdis was the first IRC server to implement SASL
    support, resulting in the IRCv3 SASL standards.
  * DNS blocklist support
  * Augmented banlist criteria through “extbans”
  * Channel forwarding (channel mode +f)
  * Optional hostname/IP cloaking (through modules, either usermode +h or
    +x)
  * Colorcode stripping (channel mode +c)
  * CALLERID (user mode +g) with automatic accept when you send a PM
  * TLS encrypted client and server connections
  * Multi-process sandbox architecture for enhanced security, scalability
    and robustness
  * Easy to understand configuration
  * A complete user and operator’s manual
 .
 Many of the largest networks in the world use charybdis-based IRC
 servers, including freenode, EsperNet, DarkMyst and others, because
 of it’s proven scalability, security and robustness track records

Package: charybdis-dbg
Architecture: any
Section: debug
Priority: extra
Depends: charybdis (= ${binary:Version}),
         ${misc:Depends}
Description: fast, scalable irc server
 This package provides debugging symbols for the Charybdis package.

=== debian/rules ===
--- 
+++ 
@@ -54,6 +54,9 @@
     CONFIGURE_ARGS+=--with-nicklen=$(DEB_NICKLEN)
 endif
 
+EXTERNAL_BUILD_TIMESTAMP?=$(shell LC_ALL=C date --utc -d "$$(dpkg-parsechangelog | sed -n -e 's/^Date: //p')")
+export EXTERNAL_BUILD_TIMESTAMP
+
 override_dh_auto_configure:
 	autoreconf -fi
 	cd libratbox ; autoreconf # necessary because we patch configure.ac
@@ -68,6 +71,7 @@
 		--with-logdir=/var/log/charybdis \
 		--with-moduledir=/usr/lib/charybdis/modules \
 		--with-helpdir=/usr/share/doc/charybdis/help \
+		--with-shared-sqlite \
 		--enable-ipv6
 
 override_dh_auto_install:
@@ -75,8 +79,9 @@
 	rmdir $(CURDIR)/debian/charybdis/var/run/charybdis || true
         # remove when it fails, it means upstream stopped shipping .la files, yay
 	rm $(CURDIR)/debian/charybdis/usr/lib/charybdis/libratbox.la
-        # remove when this fail (when the binary is renamed), see https://github.com/atheme/charybdis/pull/28
-	mv $(CURDIR)/debian/charybdis/usr/bin/charybdis-genssl.sh $(CURDIR)/debian/charybdis/usr/bin/charybdis-genssl
+        # see https://github.com/atheme/charybdis/issues/23
+        # maybe this should be in /usr/share/doc, but then users won't know when to update their configs...
+	mv $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf.example $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf
 
 override_dh_strip:
 	dh_strip --dbg-package=charybdis-dbg

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

https://www.stack.nl/~jilles/irc/ charybdis-(.*)\.tbz2

## charybdis 3.5.2p1

=== debian/changelog ===
charybdis (3.5.2p1-2) unstable; urgency=high

  * remove redundant service handlers already installed by dh_installinit
  * fix potential security issue: do not recurse with chmod
  * add upstream patch to workaround ssld crash

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 17 Aug 2016 13:44:08 -0400

charybdis (3.5.2p1-1) unstable; urgency=medium

  * new upstream release
  * clarify patches forward status
  * update standards version, no change
  * convert TODO to org mode
  * mark a todo as done
  * use "service" instead of "invoke-rc.d"
  * re-enable hardening flags, still failing
  * bump standards version: no change
  * update copyright file to follow standards and silence warnings
  * update watch file to follow new upstream location
  * restart daemon in one shot, after upgrade completed

 -- Antoine Beaupré <anarcat@debian.org>  Sat, 13 Aug 2016 15:16:59 -0400

=== debian/watch ===
--- 
+++ 
@@ -6,4 +6,4 @@
 # Compulsory line, this is a version 3 file
 version=3
 
-https://www.stack.nl/~jilles/irc/ charybdis-(.*)\.tbz2
+http://distfiles.charybdis.io/ charybdis-(.*)\.tar.bz2

## charybdis 3.5.3

=== debian/changelog ===
charybdis (3.5.3-1) unstable; urgency=high

  * new upstream release
  * fix security issue "certificate fingerprint spoofing through crafted
    SASL messages", CVE-2016-7143 (Closes: #836714)
  * drop patch null-deref-fix.patch, factored in upstream
  * ignore alpha/beta/RC releases upstream, we want to follow the stable
    stuff

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 05 Sep 2016 18:16:17 -0400

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libsqlite3-dev,
                bison | byacc,
                flex
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Homepage: http://www.charybdis.io/
 Vcs-Git: git://anonscm.debian.org/collab-maint/charybdis.git -b debian
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/charybdis.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -61,6 +61,7 @@
 	autoreconf -fi
 	cd libratbox ; autoreconf # necessary because we patch configure.ac
 	cd libratbox ; automake
+        # XXX: too much stuff here, see https://github.com/atheme/charybdis/issues/14
 	dh_auto_configure -- --prefix=/usr --with-confdir=/etc/charybdis \
 		${CONFIGURE_ARGS} \
 		--with-program-prefix=charybdis- \
@@ -83,6 +84,10 @@
         # maybe this should be in /usr/share/doc, but then users won't know when to update their configs...
 	mv $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf.example $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf
 
+# restart only after upgrades to reduce downtime
+override_dh_installinit:
+	dh_installinit -R
+
 override_dh_strip:
 	dh_strip --dbg-package=charybdis-dbg

=== debian/watch ===
--- 
+++ 
@@ -6,4 +6,4 @@
 # Compulsory line, this is a version 3 file
 version=3
 
-http://distfiles.charybdis.io/ charybdis-(.*)\.tar.bz2
+opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ http://distfiles.charybdis.io/ charybdis-(.*)(?<!beta\d)(?<!rc\d)\.tar.bz2

## charybdis 3.5.5

=== debian/changelog ===
charybdis (3.5.5-2build2) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:44:33 +0000

charybdis (3.5.5-2build1) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:42:46 +0000

charybdis (3.5.5-2) unstable; urgency=medium

  [ Unit 193 ]
  * d/rules: Fix tabs-vs-spaces for a few comments.
  * d/rules: Re-enable hardening, append LDFLAGS to link only as needed.
  * d/rules: Simplify logic for checking which TLS library to use.

  [ Antoine Beapré ]
  * switch to embedtls by default: linking across servers work (and not
    with gnutls) and there are no licensing issues (like openssl)
    (Closes: #705369)

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 03 Aug 2017 12:47:26 -0400

charybdis (3.5.5-1) unstable; urgency=medium

  [ Antoine Beaupré ]
  * new upstream release to factor in patches
  * add missing dependency on lsb-base
  * remove -dbg package, now automatically built

  [ Unit 193 ]
  * stop Build-Depending on libgcrypt11-dev transition package (Closes: #864096)
  * fix watchfile to follow github

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 20 Jul 2017 20:31:56 -0400

charybdis (3.5.4-1) experimental; urgency=medium

  * new upstream release
  * two patches to fix GnuTLS support

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 28 Feb 2017 16:36:40 -0500

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: charybdis
 Section: net
 Priority: optional
-Maintainer: Antoine Beaupré <anarcat@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Antoine Beaupré <anarcat@debian.org>
 Build-Depends: debhelper (>= 9.0.0),
                autotools-dev,
                autoconf,
                automake,
                libtool,
                pkg-config,
-               libgnutls28-dev,
-               libgcrypt11-dev,
+               libmbedtls-dev | libgnutls28-dev | libssl-dev,
+               libgcrypt20-dev,
                libz-dev,
                libsqlite3-dev,
                bison | byacc,
@@ -23,6 +24,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
+         lsb-base (>= 3.0-6),
          adduser
 Provides: ircd
 Description: fast, scalable irc server
@@ -54,12 +56,3 @@
  Many of the largest networks in the world use charybdis-based IRC
  servers, including freenode, EsperNet, DarkMyst and others, because
  of it’s proven scalability, security and robustness track records
-
-Package: charybdis-dbg
-Architecture: any
-Section: debug
-Priority: extra
-Depends: charybdis (= ${binary:Version}),
-         ${misc:Depends}
-Description: fast, scalable irc server
- This package provides debugging symbols for the Charybdis package.

=== debian/rules ===
--- 
+++ 
@@ -18,8 +18,8 @@
 
 DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
 
-# workaround for https://github.com/atheme/charybdis/issues/27
-export DEB_BUILD_MAINT_OPTIONS=hardening=-all
+export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 
 ifeq ($(DEB_HOST_ARCH_OS), linux)
     CONFIGURE_ARGS+=--enable-epoll
@@ -35,19 +35,17 @@
    CONFIGURE_ARGS+=--enable-warnings --enable-iodebug
 endif
 
-# allow users to build with OpenSSL even if it possibly breaks the
-# GPL, as we have no exception from all the authors of ircd
+# this flag allows builders to use another TLS library as a backend.
 #
-# this is not necessary in Wheezy, as there is an OpenSSL
-# compatibility layer in GNUTLS
-#
-# for this to work, you need to manually install libssl-dev
-export DEB_USE_OPENSSL
+# see README.source for details
+export DEB_TLS_LIB
 
-ifdef DEB_USE_OPENSSL
-    CONFIGURE_ARGS+=--enable-openssl
+ifeq ($(DEB_TLS_LIB), openssl)
+	CONFIGURE_ARGS+=--enable-openssl
+else ifeq ($(DEB_TLS_LIB), gnutls)
+	CONFIGURE_ARGS+=--disable-openssl --enable-gnutls
 else
-    CONFIGURE_ARGS+=--disable-openssl --enable-gnutls
+	CONFIGURE_ARGS+=--disable-openssl --enable-mbedtls
 endif
 
 ifdef DEB_NICKLEN
@@ -78,18 +76,15 @@
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/charybdis
 	rmdir $(CURDIR)/debian/charybdis/var/run/charybdis || true
-        # remove when it fails, it means upstream stopped shipping .la files, yay
+	# remove when it fails, it means upstream stopped shipping .la files, yay
 	rm $(CURDIR)/debian/charybdis/usr/lib/charybdis/libratbox.la
-        # see https://github.com/atheme/charybdis/issues/23
-        # maybe this should be in /usr/share/doc, but then users won't know when to update their configs...
+	# see https://github.com/atheme/charybdis/issues/23
+	# maybe this should be in /usr/share/doc, but then users won't know when to update their configs...
 	mv $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf.example $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf
 
 # restart only after upgrades to reduce downtime
 override_dh_installinit:
 	dh_installinit -R
 
-override_dh_strip:
-	dh_strip --dbg-package=charybdis-dbg
-
 %:
 	dh $@ --with autotools_dev

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
	https://github.com/charybdis-ircd/charybdis/releases .*/charybdis-(.*)(?<!beta\d)(?<!rc\d)(?<!m\d)\.tar\.(?:bz2|gz|xz)

## charybdis 4.1

=== debian/changelog ===
charybdis (4.1-1) unstable; urgency=medium

  [ Chris West (Faux) ]
  * new upstream release, picking up both patches
  * new build-dep for autotools
  * update rules for rename of source folder

  [ Antoine Beaupré ]
  * enable -PIE hardening, upstream seems to compile properly with that
    now
  * move to salsa and fix homepage
  * silence lintian warnings:
    * remove --with autotools_dev
  * remove another .la file create upstream
  * remove non-standard /usr/logs directory created upstream (fixed in
    later releases)
  * switch to upstream --enable-fhs-paths
  * bump standards and dh compatibility levels: no change

  [ Unit 193 ]
  * Run wrap-and-sort -a.
  * d/control, d/rules, d/README.source: Switch to using build profiles.
  * d/rules:
    - Enable pie hardening as well, no longer causes ftbfs.
    - Don't define DEB_HOST_ARCH_OS, instead include default.mk.
    - Derive EXTERNAL_BUILD_TIMESTAMP from SOURCE_DATE_EPOCH.
    - Follow renaming of ratbox to remove .la file, also remove libircd.la.
    - Define localstatedir, helpdir, and rundir.
  * d/init.d: Follow renaming of the binary to 'charybdis'.
  * d/copyright: Update format and source fields.
  * d/control:
    - Drop build-depends on autotools-dev, autoconf, automake and libtool.
    - Build-depend on libltdl-dev.
    - Add myself to uploaders.

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 20 Feb 2018 12:06:34 -0500

=== debian/control ===
--- 
+++ 
@@ -1,31 +1,30 @@
 Source: charybdis
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Antoine Beaupré <anarcat@debian.org>
-Build-Depends: debhelper (>= 9.0.0),
-               autotools-dev,
-               autoconf,
-               automake,
-               libtool,
-               pkg-config,
-               libmbedtls-dev | libgnutls28-dev | libssl-dev,
+Maintainer: Antoine Beaupré <anarcat@debian.org>
+Uploaders: Unit 193 <unit193@ubuntu.com>
+Build-Depends: debhelper (>= 10~),
+               bison | byacc,
+               flex,
                libgcrypt20-dev,
+               libgnutls28-dev <pkg.charybdis.gnutls>,
+               libltdl-dev,
+               libmbedtls-dev <!pkg.charybdis.gnutls !pkg.charybdis.openssl>,
+               libsqlite3-dev,
+               libssl-dev <pkg.charybdis.openssl>,
                libz-dev,
-               libsqlite3-dev,
-               bison | byacc,
-               flex
-Standards-Version: 3.9.8
-Homepage: http://www.charybdis.io/
-Vcs-Git: git://anonscm.debian.org/collab-maint/charybdis.git -b debian
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/charybdis.git;a=summary
+               pkg-config
+Standards-Version: 4.1.1
+Homepage: http://atheme.org/projects/charybdis.html
+Vcs-Git: https://salsa.debian.org/debian/charybdis.git -b debian
+Vcs-Browser: https://salsa.debian.org/debian/charybdis
 
 Package: charybdis
 Architecture: any
-Depends: ${shlibs:Depends},
+Depends: adduser,
+         lsb-base (>= 3.0-6),
          ${misc:Depends},
-         lsb-base (>= 3.0-6),
-         adduser
+         ${shlibs:Depends}
 Provides: ircd
 Description: fast, scalable irc server
  Charybdis is a highly scalable IRC server which presently implements

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

include /usr/share/dpkg/default.mk

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifeq ($(DEB_HOST_ARCH_OS), linux)
    CONFIGURE_ARGS+=--enable-epoll
else ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
    CONFIGURE_ARGS+=--enable-kqueue
else ifeq ($(DEB_HOST_ARCH_OS), solaris)
    CONFIGURE_ARGS+=--enable-ports
else
    CONFIGURE_ARGS+=--enable-poll
endif

ifdef DEB_DEBUG
   CONFIGURE_ARGS+=--enable-warnings --enable-iodebug
endif

ifneq ($(filter pkg.charybdis.openssl,$(DEB_BUILD_PROFILES)),)
	CONFIGURE_ARGS+=--enable-openssl
else ifneq ($(filter pkg.charybdis.gnutls,$(DEB_BUILD_PROFILES)),)
	CONFIGURE_ARGS+=--disable-openssl --enable-gnutls
else
	CONFIGURE_ARGS+=--disable-openssl --enable-mbedtls
endif

ifdef DEB_NICKLEN
    CONFIGURE_ARGS+=--with-nicklen=$(DEB_NICKLEN)
endif

EXTERNAL_BUILD_TIMESTAMP?=$(shell LC_ALL=C date --utc -d @$(SOURCE_DATE_EPOCH))
export EXTERNAL_BUILD_TIMESTAMP

override_dh_auto_configure:
        # XXX: too much stuff here, see https://github.com/atheme/charybdis/issues/14
	dh_auto_configure -- --prefix=/usr --with-confdir=/etc/charybdis \
		${CONFIGURE_ARGS} \
		--with-program-prefix=charybdis- \
		--enable-fhs-paths \
		--libdir=/usr/lib/charybdis/ \
		--localstatedir=/var/lib/ \
		--with-helpdir=/usr/share/doc/charybdis/help/ \
		--with-logdir=/var/log/charybdis/ \
		--with-rundir=/var/run/ \
		--with-shared-sqlite \
		--enable-ipv6

override_dh_auto_install:
	dh_auto_install --destdir=debian/charybdis
	# spurious logs directory creation upstream, remove when fails
	# fixed upstream: https://github.com/charybdis-ircd/charybdis/commit/550e03fadc91160991e1bbc0f7a7d193f48640ce#diff-c949f93d03f44a4217d7a138f9e2e54a
	rmdir $(CURDIR)/debian/charybdis/usr/logs
	# remove when it fails, it means upstream stopped shipping .la files, yay
	rm $(CURDIR)/debian/charybdis/usr/lib/charybdis/librb.la
	rm $(CURDIR)/debian/charybdis/usr/lib/charybdis/libircd.la
	# see https://github.com/atheme/charybdis/issues/23
	# maybe this should be in /usr/share/doc, but then users won't know when to update their configs...
	mv $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf.example $(CURDIR)/debian/charybdis/etc/charybdis/ircd.conf

# restart only after upgrades to reduce downtime
override_dh_installinit:
	dh_installinit -R

%:
	dh $@

## charybdis 4.1.1

=== debian/changelog ===
charybdis (4.1.1-1) unstable; urgency=medium

  * New upstream release (Closes: #906879).

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 21 Aug 2018 17:52:12 -0400

charybdis (4.1-2) unstable; urgency=medium

  [ Unit 193 ]
  * Bump Standards-Version to 4.1.5.

  [ Antoine Beaupré ]
  * correctly install modules in /usr/lib/charybdis/modules while keeping
    other libs private

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 27 Jul 2018 10:57:48 -0400

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libssl-dev <pkg.charybdis.openssl>,
                libz-dev,
                pkg-config
-Standards-Version: 4.1.1
+Standards-Version: 4.1.5
 Homepage: http://atheme.org/projects/charybdis.html
 Vcs-Git: https://salsa.debian.org/debian/charybdis.git -b debian
 Vcs-Browser: https://salsa.debian.org/debian/charybdis

=== debian/rules ===
--- 
+++ 
@@ -61,6 +61,7 @@
 		--with-helpdir=/usr/share/doc/charybdis/help/ \
 		--with-logdir=/var/log/charybdis/ \
 		--with-rundir=/var/run/ \
+		--with-moduledir=/usr/lib/charybdis/modules \
 		--with-shared-sqlite \
 		--enable-ipv6

## charybdis 4.1.2

=== debian/changelog ===
charybdis (4.1.2-1) unstable; urgency=medium

  [ Antoine Beaupré ]
  * clean out automatically generated file correctly
  * fix reload target in systemd

  [ Unit 193 ]
  * New upstream release.
  * d/compat, d/control:
    - Drop d/compat in favor of debhelper-compat, bump to 12.
  * d/control:
    - Set homepage to github project.
    - Pre-Depend on ${misc:Pre-Depends}.
  * Update Standards-Version to 4.4.0.

 -- Unit 193 <unit193@ubuntu.com>  Sun, 08 Sep 2019 19:19:56 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Antoine Beaupré <anarcat@debian.org>
 Uploaders: Unit 193 <unit193@ubuntu.com>
-Build-Depends: debhelper (>= 10~),
+Build-Depends: debhelper-compat (= 12),
                bison | byacc,
                flex,
                libgcrypt20-dev,
@@ -14,13 +14,14 @@
                libssl-dev <pkg.charybdis.openssl>,
                libz-dev,
                pkg-config
-Standards-Version: 4.1.5
-Homepage: http://atheme.org/projects/charybdis.html
+Standards-Version: 4.4.0
+Homepage: https://github.com/charybdis-ircd/charybdis
 Vcs-Git: https://salsa.debian.org/debian/charybdis.git -b debian
 Vcs-Browser: https://salsa.debian.org/debian/charybdis
 
 Package: charybdis
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: adduser,
          lsb-base (>= 3.0-6),
          ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -81,5 +81,9 @@
 override_dh_installinit:
 	dh_installinit -R
 
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f include/serno.h
+
 %:
 	dh $@
